package baz.movie.player;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = true;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "baz.movie.player", "baz.movie.player.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "baz.movie.player", "baz.movie.player.main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static String _txt_file = "";
public static String _txt_line = "";
public anywheresoftware.b4a.objects.streams.File.TextReaderWrapper _txt_reader = null;
public static String[] _mysubs = null;
public static int _ipass = 0;
public static int _make_it_work = 0;
public static int _int_mins = 0;
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 29;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 34;BA.debugLine="Activity.LoadLayout(\"frmMain\")";
mostCurrent._activity.LoadLayout("frmMain",mostCurrent.activityBA);
 //BA.debugLineNum = 39;BA.debugLine="make_it_work=1";
_make_it_work = (int)(1);
 //BA.debugLineNum = 41;BA.debugLine="For ipass=1 To 30";
{
final double step9 = 1;
final double limit9 = (int)(30);
for (_ipass = (int)(1); (step9 > 0 && _ipass <= limit9) || (step9 < 0 && _ipass >= limit9); _ipass += step9) {
 //BA.debugLineNum = 42;BA.debugLine="load_selected_movie_list";
_load_selected_movie_list();
 }
};
 //BA.debugLineNum = 45;BA.debugLine="make_it_work=0";
_make_it_work = (int)(0);
 //BA.debugLineNum = 49;BA.debugLine="For ipass=1 To 30";
{
final double step13 = 1;
final double limit13 = (int)(30);
for (_ipass = (int)(1); (step13 > 0 && _ipass <= limit13) || (step13 < 0 && _ipass >= limit13); _ipass += step13) {
 //BA.debugLineNum = 50;BA.debugLine="load_selected_movie_list";
_load_selected_movie_list();
 }
};
 //BA.debugLineNum = 54;BA.debugLine="End Sub";
return "";
}
public static int  _cstr_int(String _mystr) throws Exception{
int _myint = 0;
String _mys = "";
 //BA.debugLineNum = 98;BA.debugLine="Sub cstr_int(mystr As String) As Int";
 //BA.debugLineNum = 100;BA.debugLine="Dim myint As Int, mys As String";
_myint = 0;
_mys = "";
 //BA.debugLineNum = 101;BA.debugLine="mys= mystr";
_mys = _mystr;
 //BA.debugLineNum = 102;BA.debugLine="If(make_it_work=1) Then mys=mys & \" \"";
if ((_make_it_work==1)) { 
_mys = _mys+" ";};
 //BA.debugLineNum = 104;BA.debugLine="Try";
try { //BA.debugLineNum = 105;BA.debugLine="myint=mys";
_myint = (int)(Double.parseDouble(_mys));
 } 
       catch (Exception e38) {
			processBA.setLastException(e38); //BA.debugLineNum = 107;BA.debugLine="Log(\"string hassle >\" & mys & \"<  \" & mys.Length)";
anywheresoftware.b4a.keywords.Common.Log("string hassle >"+_mys+"<  "+BA.NumberToString(_mys.length()));
 //BA.debugLineNum = 108;BA.debugLine="Try";
try { //BA.debugLineNum = 109;BA.debugLine="myint=mys";
_myint = (int)(Double.parseDouble(_mys));
 } 
       catch (Exception e42) {
			processBA.setLastException(e42); //BA.debugLineNum = 111;BA.debugLine="Log(\"tried again\")";
anywheresoftware.b4a.keywords.Common.Log("tried again");
 //BA.debugLineNum = 112;BA.debugLine="myint=mys";
_myint = (int)(Double.parseDouble(_mys));
 //BA.debugLineNum = 113;BA.debugLine="Log (\"done 2nd time\")";
anywheresoftware.b4a.keywords.Common.Log("done 2nd time");
 };
 //BA.debugLineNum = 115;BA.debugLine="Log(\"done\")";
anywheresoftware.b4a.keywords.Common.Log("done");
 };
 //BA.debugLineNum = 117;BA.debugLine="Return myint";
if (true) return _myint;
 //BA.debugLineNum = 119;BA.debugLine="End Sub";
return 0;
}

public static void initializeProcessGlobals() {
    
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 19;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 23;BA.debugLine="Dim txt_file As String, txt_line As String, txt_reader As TextReader";
mostCurrent._txt_file = "";
mostCurrent._txt_line = "";
mostCurrent._txt_reader = new anywheresoftware.b4a.objects.streams.File.TextReaderWrapper();
 //BA.debugLineNum = 24;BA.debugLine="Dim mysubs(100) As String, ipass As Int, make_it_work As Int, int_mins As Int";
mostCurrent._mysubs = new String[(int)(100)];
java.util.Arrays.fill(mostCurrent._mysubs,"");
_ipass = 0;
_make_it_work = 0;
_int_mins = 0;
 //BA.debugLineNum = 27;BA.debugLine="End Sub";
return "";
}
public static String  _load_selected_movie_list() throws Exception{
String _dumstr = "";
 //BA.debugLineNum = 55;BA.debugLine="Sub load_selected_movie_list";
 //BA.debugLineNum = 57;BA.debugLine="Dim dumstr As String";
_dumstr = "";
 //BA.debugLineNum = 59;BA.debugLine="txt_file=\"movie_list.txt\"";
mostCurrent._txt_file = "movie_list.txt";
 //BA.debugLineNum = 61;BA.debugLine="txt_reader.Initialize(File.OpenInput(File.DirAssets ,txt_file))";
mostCurrent._txt_reader.Initialize((java.io.InputStream)(anywheresoftware.b4a.keywords.Common.File.OpenInput(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),mostCurrent._txt_file).getObject()));
 //BA.debugLineNum = 63;BA.debugLine="txt_line=txt_reader.ReadLine";
mostCurrent._txt_line = mostCurrent._txt_reader.ReadLine();
 //BA.debugLineNum = 65;BA.debugLine="Do While txt_line <> Null";
while (mostCurrent._txt_line!= null) {
 //BA.debugLineNum = 67;BA.debugLine="mysubs=Regex.Split(\",\",txt_line)";
mostCurrent._mysubs = anywheresoftware.b4a.keywords.Common.Regex.Split(",",mostCurrent._txt_line);
 //BA.debugLineNum = 69;BA.debugLine="dumstr=mysubs(5)";
_dumstr = mostCurrent._mysubs[(int)(5)];
 //BA.debugLineNum = 80;BA.debugLine="int_mins=cstr_int(mysubs(5))";
_int_mins = _cstr_int(mostCurrent._mysubs[(int)(5)]);
 //BA.debugLineNum = 89;BA.debugLine="txt_line=txt_reader.ReadLine";
mostCurrent._txt_line = mostCurrent._txt_reader.ReadLine();
 }
;
 //BA.debugLineNum = 93;BA.debugLine="txt_reader.close";
mostCurrent._txt_reader.Close();
 //BA.debugLineNum = 95;BA.debugLine="Log(\"finished pass \" & ipass)";
anywheresoftware.b4a.keywords.Common.Log("finished pass "+BA.NumberToString(_ipass));
 //BA.debugLineNum = 97;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 17;BA.debugLine="End Sub";
return "";
}
}
